package com.sqx.modules.common.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sqx.common.utils.Result;
import com.sqx.modules.common.dao.CommonInfoDao;
import com.sqx.modules.common.entity.CommonInfo;
import com.sqx.modules.common.service.CommonInfoService;
import com.sqx.modules.course.service.CourseService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.CacheManager;
import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author fang
 * @date 2020/7/8
 */
@CacheConfig(cacheNames = "common")
@Service
public class CommonInfoServiceImpl extends ServiceImpl<CommonInfoDao, CommonInfo> implements CommonInfoService {

    @Autowired
    private CommonInfoDao commonInfoDao;
    @Autowired
    private CourseService courseService;

    @Autowired
    private CacheManager cacheManager;


    @CacheEvict(key = "#commonInfo.id")
    @Override
    public Result update(CommonInfo commonInfo) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date now = new Date();
        commonInfo.setCreateAt(sdf.format(now));
        if (commonInfo.getType() == 820) {
            Result result = courseService.setDyNotifyUrl(commonInfo.getValue());
            String code = String.valueOf(result.get("code"));
            if (!"0".equals(code)) {
                return result;
            }
        }
        commonInfoDao.updateById(commonInfo);
        cleanAppKv();
        return Result.success();
    }

    @Override
    public CommonInfo findOne(int type) {
        return commonInfoDao.findOne(type);
    }

    @CacheEvict(key = "#id")
    @Override
    public Result delete(long id) {
        commonInfoDao.deleteById(id);
        cleanAppKv();
        return Result.success();
    }

    @CacheEvict(key = "#commonInfo.id")
    @Override
    public Result updateBody(CommonInfo commonInfo) {
        commonInfoDao.updateById(commonInfo);
        cleanAppKv();
        return Result.success();
    }

    @Override
    public Result findByType(Integer type) {
        return Result.success().put("data", commonInfoDao.findOne(type));
    }

    @Override
    public Result findByTypeAndCondition(String condition) {
        return Result.success().put("data", commonInfoDao.findByCondition(condition));
    }

    @Override
    @Cacheable("commonInfoAppKv")
    public Map<Integer, String> findAppKv() {
        List<CommonInfo> list = commonInfoDao.selectList(Wrappers.<CommonInfo>lambdaQuery().eq(CommonInfo::getIsAppUse, 1).orderByAsc(CommonInfo::getType).orderByAsc(CommonInfo::getId));
        if (CollUtil.isEmpty(list)) {
            return new HashMap<>(0);
        }
        Map<Integer, String> data = list.stream().collect(Collectors.toMap(CommonInfo::getType, CommonInfo::getValue));
        return data;
    }

    @Override
    public void cleanAppKv() {
        cacheManager.getCache("commonInfoAppKv").clear();
    }

}